/*
 * ADBMS_LL_Driver.h
 *
 *  Created on: 05.06.2022
 *      Author: max
 */

#ifndef ADBMS_LL_DRIVER_H_
#define ADBMS_LL_DRIVER_H_

#include "stm32h7xx_hal.h"
#include <stdint.h>
#define TARGET_STM32

#ifdef TARGET_STM32
typedef uint8_t uint8;
typedef uint16_t uint16;
typedef uint32_t uint32;
#endif

uint8 adbmsDriverInit(SPI_HandleTypeDef* hspi);

uint8 writeCMD(uint16 command, uint8* args, uint8 arglen);
uint8 readCMD(uint16 command, uint8* buffer, uint8 buflen);
uint8 pollCMD(uint16 command);

void mcuAdbmsCSLow();
void mcuAdbmsCSHigh();

uint8 wakeUpCmd();
static inline void mcuDelay(uint16 delay) { HAL_Delay(delay); };

#endif /* ADBMS_LL_DRIVER_H_ */
